Index: /NEMO/trunk/src/OCE/BDY/bdydta.F90
===================================================================
--- /NEMO/trunk/src/OCE/BDY/bdydta.F90	(revision 11535)
+++ /NEMO/trunk/src/OCE/BDY/bdydta.F90	(revision 11536)
@@ -43,18 +43,28 @@
    PUBLIC   bdy_dta_init     ! routine called by nemogcm.F90
 
-   INTEGER, ALLOCATABLE, DIMENSION(:)   ::   nb_bdy_fld        ! Number of fields to update for each boundary set.
-   INTEGER                              ::   nb_bdy_fld_sum    ! Total number of fields to update for all boundary sets.
-   LOGICAL,           DIMENSION(jp_bdy) ::   ln_full_vel_array ! =T => full velocities in 3D boundary conditions
-                                                               ! =F => baroclinic velocities in 3D boundary conditions
+   INTEGER , PARAMETER ::   jpbdyfld  = 16    ! maximum number of files to read 
+   INTEGER , PARAMETER ::   jp_bdyssh = 1     ! 
+   INTEGER , PARAMETER ::   jp_bdyu2d = 2     ! 
+   INTEGER , PARAMETER ::   jp_bdyv2d = 3     !
+   INTEGER , PARAMETER ::   jp_bdyu3d = 4     !
+   INTEGER , PARAMETER ::   jp_bdyv3d = 5     !
+   INTEGER , PARAMETER ::   jp_bdytem = 6     ! 
+   INTEGER , PARAMETER ::   jp_bdysal = 7     ! 
+   INTEGER , PARAMETER ::   jp_bdya_i = 8     ! 
+   INTEGER , PARAMETER ::   jp_bdyh_i = 9     ! 
+   INTEGER , PARAMETER ::   jp_bdyh_s = 10    ! 
+   INTEGER , PARAMETER ::   jp_bdyt_i = 11    ! 
+   INTEGER , PARAMETER ::   jp_bdyt_s = 12    ! 
+   INTEGER , PARAMETER ::   jp_bdytsu = 13    ! 
+   INTEGER , PARAMETER ::   jp_bdys_i = 14    ! 
+   INTEGER , PARAMETER ::   jp_bdyaip = 15    ! 
+   INTEGER , PARAMETER ::   jp_bdyhip = 16    ! 
+#if ! defined key_si3
+   INTEGER , PARAMETER ::   jpl = 1
+#endif
+
 !$AGRIF_DO_NOT_TREAT
-   TYPE(FLD), PUBLIC, ALLOCATABLE, DIMENSION(:), TARGET ::   bf        ! structure of input fields (file informations, fields read)
+   TYPE(FLD), PUBLIC, ALLOCATABLE, DIMENSION(:,:), TARGET ::   bf   ! structure of input fields (file informations, fields read)
 !$AGRIF_END_DO_NOT_TREAT
-   TYPE(MAP_POINTER), ALLOCATABLE, DIMENSION(:) :: nbmap_ptr   ! array of pointers to nbmap
-
-#if defined key_si3
-   INTEGER ::   nice_cat                      ! number of categories in the input file
-   INTEGER ::   jfld_hti, jfld_hts, jfld_ai   ! indices of ice thickness, snow thickness and concentration in bf structure
-   INTEGER, DIMENSION(jp_bdy) :: jfld_htit, jfld_htst, jfld_ait
-#endif
 
    !!----------------------------------------------------------------------
@@ -65,5 +75,5 @@
 CONTAINS
 
-      SUBROUTINE bdy_dta( kt, jit, time_offset )
+   SUBROUTINE bdy_dta( kt, kit, kt_offset )
       !!----------------------------------------------------------------------
       !!                   ***  SUBROUTINE bdy_dta  ***
@@ -75,17 +85,18 @@
       !!----------------------------------------------------------------------
       INTEGER, INTENT(in)           ::   kt           ! ocean time-step index 
-      INTEGER, INTENT(in), OPTIONAL ::   jit          ! subcycle time-step index (for timesplitting option)
-      INTEGER, INTENT(in), OPTIONAL ::   time_offset  ! time offset in units of timesteps. NB. if jit
+      INTEGER, INTENT(in), OPTIONAL ::   kit          ! subcycle time-step index (for timesplitting option)
+      INTEGER, INTENT(in), OPTIONAL ::   kt_offset    ! time offset in units of timesteps. NB. if kit
       !                                               ! is present then units = subcycle timesteps.
-      !                                               ! time_offset = 0 => get data at "now" time level
-      !                                               ! time_offset = -1 => get data at "before" time level
-      !                                               ! time_offset = +1 => get data at "after" time level
+      !                                               ! kt_offset = 0 => get data at "now" time level
+      !                                               ! kt_offset = -1 => get data at "before" time level
+      !                                               ! kt_offset = +1 => get data at "after" time level
       !                                               ! etc.
       !
-      INTEGER ::  jbdy, jfld, jstart, jend, ib, jl  ! dummy loop indices
-      INTEGER ::  ii, ij, ik, igrd                  ! local integers
-      INTEGER,          DIMENSION(jpbgrd) ::   ilen1 
-      INTEGER, POINTER, DIMENSION(:)      ::   nblen, nblenrim  ! short cuts
-      TYPE(OBC_DATA), POINTER             ::   dta              ! short cut
+      INTEGER ::  jbdy, jfld, jstart, jend, ib, jl    ! dummy loop indices
+      INTEGER ::  ii, ij, ik, igrd, ipl               ! local integers
+      INTEGER,   DIMENSION(jpbgrd)     ::   ilen1 
+      INTEGER,   DIMENSION(:), POINTER ::   nblen, nblenrim  ! short cuts
+      TYPE(OBC_DATA)         , POINTER ::   dta_alias        ! short cut
+      TYPE(FLD), DIMENSION(:), POINTER ::   bf_alias
       !!---------------------------------------------------------------------------
       !
@@ -94,18 +105,17 @@
       ! Initialise data arrays once for all from initial conditions where required
       !---------------------------------------------------------------------------
-      IF( kt == nit000 .AND. .NOT.PRESENT(jit) ) THEN
+      IF( kt == nit000 .AND. .NOT.PRESENT(kit) ) THEN
 
          ! Calculate depth-mean currents
          !-----------------------------
-         
+
          DO jbdy = 1, nb_bdy
             !
             nblen    => idx_bdy(jbdy)%nblen
             nblenrim => idx_bdy(jbdy)%nblenrim
-            dta      => dta_bdy(jbdy)
             !
             IF( nn_dyn2d_dta(jbdy) == 0 ) THEN 
                ilen1(:) = nblen(:)
-               IF( dta%ll_ssh ) THEN 
+               IF( dta_bdy(jbdy)%lneed_ssh ) THEN 
                   igrd = 1
                   DO ib = 1, ilen1(igrd)
@@ -113,7 +123,7 @@
                      ij = idx_bdy(jbdy)%nbj(ib,igrd)
                      dta_bdy(jbdy)%ssh(ib) = sshn(ii,ij) * tmask(ii,ij,1)         
-                  END DO 
-               ENDIF
-               IF( dta%ll_u2d ) THEN 
+                  END DO
+               ENDIF
+               IF( dta_bdy(jbdy)%lneed_dyn2d) THEN 
                   igrd = 2
                   DO ib = 1, ilen1(igrd)
@@ -121,7 +131,5 @@
                      ij = idx_bdy(jbdy)%nbj(ib,igrd)
                      dta_bdy(jbdy)%u2d(ib) = un_b(ii,ij) * umask(ii,ij,1)         
-                  END DO 
-               ENDIF
-               IF( dta%ll_v2d ) THEN 
+                  END DO
                   igrd = 3
                   DO ib = 1, ilen1(igrd)
@@ -129,5 +137,5 @@
                      ij = idx_bdy(jbdy)%nbj(ib,igrd)
                      dta_bdy(jbdy)%v2d(ib) = vn_b(ii,ij) * vmask(ii,ij,1)         
-                  END DO 
+                  END DO
                ENDIF
             ENDIF
@@ -135,5 +143,5 @@
             IF( nn_dyn3d_dta(jbdy) == 0 ) THEN 
                ilen1(:) = nblen(:)
-               IF( dta%ll_u3d ) THEN 
+               IF( dta_bdy(jbdy)%lneed_dyn3d ) THEN 
                   igrd = 2 
                   DO ib = 1, ilen1(igrd)
@@ -143,7 +151,5 @@
                         dta_bdy(jbdy)%u3d(ib,ik) =  ( un(ii,ij,ik) - un_b(ii,ij) ) * umask(ii,ij,ik)         
                      END DO
-                  END DO 
-               ENDIF
-               IF( dta%ll_v3d ) THEN 
+                  END DO
                   igrd = 3 
                   DO ib = 1, ilen1(igrd)
@@ -152,6 +158,6 @@
                         ij = idx_bdy(jbdy)%nbj(ib,igrd)
                         dta_bdy(jbdy)%v3d(ib,ik) =  ( vn(ii,ij,ik) - vn_b(ii,ij) ) * vmask(ii,ij,ik)         
-                        END DO
-                  END DO 
+                     END DO
+                  END DO
                ENDIF
             ENDIF
@@ -159,5 +165,5 @@
             IF( nn_tra_dta(jbdy) == 0 ) THEN 
                ilen1(:) = nblen(:)
-               IF( dta%ll_tem ) THEN
+               IF( dta_bdy(jbdy)%lneed_tra ) THEN
                   igrd = 1 
                   DO ib = 1, ilen1(igrd)
@@ -165,17 +171,8 @@
                         ii = idx_bdy(jbdy)%nbi(ib,igrd)
                         ij = idx_bdy(jbdy)%nbj(ib,igrd)
-                        dta_bdy(jbdy)%tem(ib,ik) = tsn(ii,ij,ik,jp_tem) * tmask(ii,ij,ik)         
+                        dta_bdy(jbdy)%tem(ib,ik) = tsn(ii,ij,ik,jp_bdytem) * tmask(ii,ij,ik)         
+                        dta_bdy(jbdy)%sal(ib,ik) = tsn(ii,ij,ik,jp_bdysal) * tmask(ii,ij,ik)         
                      END DO
-                  END DO 
-               ENDIF
-               IF( dta%ll_sal ) THEN
-                  igrd = 1 
-                  DO ib = 1, ilen1(igrd)
-                     DO ik = 1, jpkm1
-                        ii = idx_bdy(jbdy)%nbi(ib,igrd)
-                        ij = idx_bdy(jbdy)%nbj(ib,igrd)
-                        dta_bdy(jbdy)%sal(ib,ik) = tsn(ii,ij,ik,jp_sal) * tmask(ii,ij,ik)         
-                     END DO
-                  END DO 
+                  END DO
                ENDIF
             ENDIF
@@ -184,5 +181,5 @@
             IF( nn_ice_dta(jbdy) == 0 ) THEN    ! set ice to initial values
                ilen1(:) = nblen(:)
-               IF( dta%ll_a_i ) THEN
+               IF( dta_bdy(jbdy)%lneed_ice ) THEN
                   igrd = 1   
                   DO jl = 1, jpl
@@ -190,25 +187,14 @@
                         ii = idx_bdy(jbdy)%nbi(ib,igrd)
                         ij = idx_bdy(jbdy)%nbj(ib,igrd)
-                        dta_bdy(jbdy)%a_i (ib,jl) =  a_i(ii,ij,jl) * tmask(ii,ij,1) 
-                     END DO
-                  END DO
-               ENDIF
-               IF( dta%ll_h_i ) THEN
-                  igrd = 1   
-                  DO jl = 1, jpl
-                     DO ib = 1, ilen1(igrd)
-                        ii = idx_bdy(jbdy)%nbi(ib,igrd)
-                        ij = idx_bdy(jbdy)%nbj(ib,igrd)
-                        dta_bdy(jbdy)%h_i (ib,jl) =  h_i(ii,ij,jl) * tmask(ii,ij,1) 
-                     END DO
-                  END DO
-               ENDIF
-               IF( dta%ll_h_s ) THEN
-                  igrd = 1   
-                  DO jl = 1, jpl
-                     DO ib = 1, ilen1(igrd)
-                        ii = idx_bdy(jbdy)%nbi(ib,igrd)
-                        ij = idx_bdy(jbdy)%nbj(ib,igrd)
-                        dta_bdy(jbdy)%h_s (ib,jl) =  h_s(ii,ij,jl) * tmask(ii,ij,1) 
+                        dta_bdy(jbdy)%a_i(ib,jl) =  a_i (ii,ij,jl) * tmask(ii,ij,1) 
+                        dta_bdy(jbdy)%h_i(ib,jl) =  h_i (ii,ij,jl) * tmask(ii,ij,1) 
+                        dta_bdy(jbdy)%h_s(ib,jl) =  h_s (ii,ij,jl) * tmask(ii,ij,1) 
+                        dta_bdy(jbdy)%t_i(ib,jl) =  SUM(t_i (ii,ij,:,jl)) * r1_nlay_i * tmask(ii,ij,1) 
+                        dta_bdy(jbdy)%t_s(ib,jl) =  SUM(t_s (ii,ij,:,jl)) * r1_nlay_s * tmask(ii,ij,1)
+                        dta_bdy(jbdy)%tsu(ib,jl) =  t_su(ii,ij,jl) * tmask(ii,ij,1) 
+                        dta_bdy(jbdy)%s_i(ib,jl) =  s_i (ii,ij,jl) * tmask(ii,ij,1)
+                        ! melt ponds
+                        dta_bdy(jbdy)%aip(ib,jl) =  a_ip(ii,ij,jl) * tmask(ii,ij,1) 
+                        dta_bdy(jbdy)%hip(ib,jl) =  h_ip(ii,ij,jl) * tmask(ii,ij,1) 
                      END DO
                   END DO
@@ -222,183 +208,154 @@
       ! update external data from files
       !--------------------------------
-     
-      jstart = 1
-      DO jbdy = 1, nb_bdy   
-         dta => dta_bdy(jbdy)
-         IF( nn_dta(jbdy) == 1 ) THEN ! skip this bit if no external data required
-      
-            IF( PRESENT(jit) ) THEN
-               ! Update barotropic boundary conditions only
-               ! jit is optional argument for fld_read and bdytide_update
-               IF( cn_dyn2d(jbdy) /= 'none' ) THEN
-                  IF( nn_dyn2d_dta(jbdy) == 2 ) THEN ! tidal harmonic forcing ONLY: initialise arrays
-                     IF( dta%ll_ssh ) dta%ssh(:) = 0._wp
-                     IF( dta%ll_u2d ) dta%u2d(:) = 0._wp
-                     IF( dta%ll_u3d ) dta%v2d(:) = 0._wp
-                  ENDIF
-                  IF (cn_tra(jbdy) /= 'runoff') THEN
-                     IF( nn_dyn2d_dta(jbdy) == 1 .OR. nn_dyn2d_dta(jbdy) == 3 ) THEN
-
-                        jend = jstart + dta%nread(2) - 1
-                        IF( ln_full_vel_array(jbdy) ) THEN
-                           CALL fld_read( kt=kt, kn_fsbc=1, sd=bf(jstart:jend), map=nbmap_ptr(jstart:jend),  &
-                                     & kit=jit, kt_offset=time_offset , jpk_bdy=nb_jpk_bdy(jbdy),   &
-                                     & fvl=ln_full_vel_array(jbdy)  )
-                        ELSE
-                           CALL fld_read( kt=kt, kn_fsbc=1, sd=bf(jstart:jend), map=nbmap_ptr(jstart:jend),  &
-                                     & kit=jit, kt_offset=time_offset  )
-                        ENDIF
-
-                        ! If full velocities in boundary data then extract barotropic velocities from 3D fields
-                        IF( ln_full_vel_array(jbdy) .AND.                                             &
-                          &    ( nn_dyn2d_dta(jbdy) == 1 .OR. nn_dyn2d_dta(jbdy) == 3 .OR.  &
-                          &      nn_dyn3d_dta(jbdy) == 1 ) )THEN
-
-                           igrd = 2                      ! zonal velocity
-                           dta%u2d(:) = 0._wp
-                           DO ib = 1, idx_bdy(jbdy)%nblen(igrd)
-                              ii   = idx_bdy(jbdy)%nbi(ib,igrd)
-                              ij   = idx_bdy(jbdy)%nbj(ib,igrd)
-                              DO ik = 1, jpkm1
-                                 dta%u2d(ib) = dta%u2d(ib) &
-                       &                          + e3u_n(ii,ij,ik) * umask(ii,ij,ik) * dta%u3d(ib,ik)
-                              END DO
-                              dta%u2d(ib) =  dta%u2d(ib) * r1_hu_n(ii,ij)
-                           END DO
-                           igrd = 3                      ! meridional velocity
-                           dta%v2d(:) = 0._wp
-                           DO ib = 1, idx_bdy(jbdy)%nblen(igrd)
-                              ii   = idx_bdy(jbdy)%nbi(ib,igrd)
-                              ij   = idx_bdy(jbdy)%nbj(ib,igrd)
-                              DO ik = 1, jpkm1
-                                 dta%v2d(ib) = dta%v2d(ib) &
-                       &                       + e3v_n(ii,ij,ik) * vmask(ii,ij,ik) * dta%v3d(ib,ik)
-                              END DO
-                              dta%v2d(ib) =  dta%v2d(ib) * r1_hv_n(ii,ij)
-                           END DO
-                        ENDIF                    
-                     ENDIF
-                     IF( nn_dyn2d_dta(jbdy) .ge. 2 ) THEN ! update tidal harmonic forcing
-                        CALL bdytide_update( kt=kt, idx=idx_bdy(jbdy), dta=dta, td=tides(jbdy),   & 
-                          &                 jit=jit, time_offset=time_offset )
-                     ENDIF
-                  ENDIF
-               ENDIF
-            ELSE
-               IF (cn_tra(jbdy) == 'runoff') then      ! runoff condition
-                  jend = nb_bdy_fld(jbdy)
-                  CALL fld_read( kt=kt, kn_fsbc=1, sd=bf(jstart:jend),  &
-                               & map=nbmap_ptr(jstart:jend), kt_offset=time_offset )
-                  !
-                  igrd = 2                      ! zonal velocity
-                  DO ib = 1, idx_bdy(jbdy)%nblen(igrd)
-                     ii   = idx_bdy(jbdy)%nbi(ib,igrd)
-                     ij   = idx_bdy(jbdy)%nbj(ib,igrd)
-                     dta%u2d(ib) = dta%u2d(ib) / ( e2u(ii,ij) * hu_0(ii,ij) )
-                  END DO
-                  !
-                  igrd = 3                      ! meridional velocity
-                  DO ib = 1, idx_bdy(jbdy)%nblen(igrd)
-                     ii   = idx_bdy(jbdy)%nbi(ib,igrd)
-                     ij   = idx_bdy(jbdy)%nbj(ib,igrd)
-                     dta%v2d(ib) = dta%v2d(ib) / ( e1v(ii,ij) * hv_0(ii,ij) )
-                  END DO
-               ELSE
-                  IF( nn_dyn2d_dta(jbdy) == 2 ) THEN ! tidal harmonic forcing ONLY: initialise arrays
-                     IF( dta%ll_ssh ) dta%ssh(:) = 0._wp
-                     IF( dta%ll_u2d ) dta%u2d(:) = 0._wp
-                     IF( dta%ll_v2d ) dta%v2d(:) = 0._wp
-                  ENDIF
-                  IF( dta%nread(1) .gt. 0 ) THEN ! update external data
-                     jend = jstart + dta%nread(1) - 1
-                     CALL fld_read( kt=kt, kn_fsbc=1, sd=bf(jstart:jend), &
-                                  & map=nbmap_ptr(jstart:jend), kt_offset=time_offset, jpk_bdy=nb_jpk_bdy(jbdy),   &
-                                  & fvl=ln_full_vel_array(jbdy) )
-                  ENDIF
-                  ! If full velocities in boundary data then split into barotropic and baroclinic data
-                  IF( ln_full_vel_array(jbdy) .and.                                             &
-                    & ( nn_dyn2d_dta(jbdy) == 1 .OR. nn_dyn2d_dta(jbdy) == 3 .OR. &
-                    &   nn_dyn3d_dta(jbdy) == 1 ) ) THEN
-                     igrd = 2                      ! zonal velocity
-                     dta%u2d(:) = 0._wp
-                     DO ib = 1, idx_bdy(jbdy)%nblen(igrd)
-                        ii   = idx_bdy(jbdy)%nbi(ib,igrd)
-                        ij   = idx_bdy(jbdy)%nbj(ib,igrd)
-                        DO ik = 1, jpkm1
-                           dta%u2d(ib) = dta%u2d(ib) &
-                 &                       + e3u_n(ii,ij,ik) * umask(ii,ij,ik) * dta%u3d(ib,ik)
-                        END DO
-                        dta%u2d(ib) =  dta%u2d(ib) * r1_hu_n(ii,ij)
-                        DO ik = 1, jpkm1
-                           dta%u3d(ib,ik) = dta%u3d(ib,ik) - dta%u2d(ib)
-                        END DO
-                     END DO
-                     igrd = 3                      ! meridional velocity
-                     dta%v2d(:) = 0._wp
-                     DO ib = 1, idx_bdy(jbdy)%nblen(igrd)
-                        ii   = idx_bdy(jbdy)%nbi(ib,igrd)
-                        ij   = idx_bdy(jbdy)%nbj(ib,igrd)
-                        DO ik = 1, jpkm1
-                           dta%v2d(ib) = dta%v2d(ib) &
-                 &                       + e3v_n(ii,ij,ik) * vmask(ii,ij,ik) * dta%v3d(ib,ik)
-                        END DO
-                        dta%v2d(ib) =  dta%v2d(ib) * r1_hv_n(ii,ij)
-                        DO ik = 1, jpkm1
-                           dta%v3d(ib,ik) = dta%v3d(ib,ik) - dta%v2d(ib)
-                        END DO
-                     END DO
-                  ENDIF
-
-               ENDIF
+
+      DO jbdy = 1, nb_bdy
+
+         dta_alias => dta_bdy(jbdy)
+         bf_alias  => bf(:,jbdy)
+
+         ! read/update all bdy data
+         ! ------------------------
+         CALL fld_read( kt, 1, bf_alias, kit = kit, kt_offset = kt_offset )
+
+         ! apply some corrections in some specific cases...
+         ! --------------------------------------------------
+         !
+         ! if runoff condition: change river flow we read (in m3/s) into barotropic velocity (m/s)
+         IF( cn_tra(jbdy) == 'runoff' .AND. TRIM(bf_alias(jp_bdyu2d)%clrootname) /= 'NOT USED' ) THEN   ! runoff and we read u/v2d
+            !
+            igrd = 2                      ! zonal flow (m3/s) to barotropic zonal velocity (m/s)
+            DO ib = 1, idx_bdy(jbdy)%nblen(igrd)
+               ii   = idx_bdy(jbdy)%nbi(ib,igrd)
+               ij   = idx_bdy(jbdy)%nbj(ib,igrd)
+               dta_alias%u2d(ib) = dta_alias%u2d(ib) / ( e2u(ii,ij) * hu_0(ii,ij) )
+            END DO
+            igrd = 3                      ! meridional flow (m3/s) to barotropic meridional velocity (m/s)
+            DO ib = 1, idx_bdy(jbdy)%nblen(igrd)
+               ii   = idx_bdy(jbdy)%nbi(ib,igrd)
+               ij   = idx_bdy(jbdy)%nbj(ib,igrd)
+               dta_alias%v2d(ib) = dta_alias%v2d(ib) / ( e1v(ii,ij) * hv_0(ii,ij) )
+            END DO
+         ENDIF
+
+         ! tidal harmonic forcing ONLY: initialise arrays
+         IF( nn_dyn2d_dta(jbdy) == 2 ) THEN   ! we did not read ssh, u/v2d 
+            IF( dta_alias%lneed_ssh   ) dta_alias%ssh(:) = 0._wp
+            IF( dta_alias%lneed_dyn2d ) dta_alias%u2d(:) = 0._wp
+            IF( dta_alias%lneed_dyn2d ) dta_alias%v2d(:) = 0._wp
+         ENDIF
+
+         ! If full velocities in boundary data, then split it into barotropic and baroclinic component
+         IF( bf_alias(jp_bdyu3d)%ltotvel ) THEN     ! if we read 3D total velocity (can be true only if u3d was read)
+            !
+            igrd = 2                       ! zonal velocity
+            dta_alias%u2d(:) = 0._wp       ! compute barotrope zonal velocity and put it in u2d
+            DO ib = 1, idx_bdy(jbdy)%nblen(igrd)
+               ii   = idx_bdy(jbdy)%nbi(ib,igrd)
+               ij   = idx_bdy(jbdy)%nbj(ib,igrd)
+               DO ik = 1, jpkm1
+                  dta_alias%u2d(ib) = dta_alias%u2d(ib) + e3u_n(ii,ij,ik) * umask(ii,ij,ik) * dta_alias%u3d(ib,ik)
+               END DO
+               dta_alias%u2d(ib) =  dta_alias%u2d(ib) * r1_hu_n(ii,ij)
+               DO ik = 1, jpkm1            ! compute barocline zonal velocity and put it in u3d
+                  dta_alias%u3d(ib,ik) = dta_alias%u3d(ib,ik) - dta_alias%u2d(ib)
+               END DO
+            END DO
+            igrd = 3                       ! meridional velocity
+            dta_alias%v2d(:) = 0._wp       ! compute barotrope meridional velocity and put it in v2d
+            DO ib = 1, idx_bdy(jbdy)%nblen(igrd)
+               ii   = idx_bdy(jbdy)%nbi(ib,igrd)
+               ij   = idx_bdy(jbdy)%nbj(ib,igrd)
+               DO ik = 1, jpkm1
+                  dta_alias%v2d(ib) = dta_alias%v2d(ib) + e3v_n(ii,ij,ik) * vmask(ii,ij,ik) * dta_alias%v3d(ib,ik)
+               END DO
+               dta_alias%v2d(ib) =  dta_alias%v2d(ib) * r1_hv_n(ii,ij)
+               DO ik = 1, jpkm1            ! compute barocline meridional velocity and put it in v3d
+                  dta_alias%v3d(ib,ik) = dta_alias%v3d(ib,ik) - dta_alias%v2d(ib)
+               END DO
+            END DO
+         ENDIF   ! ltotvel
+
+         ! update tidal harmonic forcing
+         IF( PRESENT(kit) .AND. nn_dyn2d_dta(jbdy) .GE. 2 ) THEN
+            CALL bdytide_update( kt = kt, idx = idx_bdy(jbdy), dta = dta_alias, td = tides(jbdy),   & 
+               &                 kit = kit, kt_offset = kt_offset )
+         ENDIF
+
+         !  atm surface pressure : add inverted barometer effect to ssh if it was read
+         IF ( ln_apr_obc .AND. TRIM(bf_alias(jp_bdyssh)%clrootname) /= 'NOT USED' ) THEN
+            igrd = 1
+            DO ib = 1, idx_bdy(jbdy)%nblenrim(igrd)   ! ssh is used only on the rim
+               ii   = idx_bdy(jbdy)%nbi(ib,igrd)
+               ij   = idx_bdy(jbdy)%nbj(ib,igrd)
+               dta_alias%ssh(ib) = dta_alias%ssh(ib) + ssh_ib(ii,ij)
+            END DO
+         ENDIF
+
 #if defined key_si3
-               ! convert N-cat fields (input) into jpl-cat (output)
-               IF( cn_ice(jbdy) /= 'none' .AND. nn_ice_dta(jbdy) == 1 ) THEN
-                  jfld_hti = jfld_htit(jbdy)
-                  jfld_hts = jfld_htst(jbdy)
-                  jfld_ai  = jfld_ait(jbdy)
-                  CALL ice_var_itd( bf(jfld_hti)%fnow(:,1,:), bf(jfld_hts)%fnow(:,1,:), bf(jfld_ai)%fnow(:,1,:), &
-                     &              dta_bdy(jbdy)%h_i       , dta_bdy(jbdy)%h_s       , dta_bdy(jbdy)%a_i      )
-               ENDIF
+         IF( dta_alias%lneed_ice ) THEN
+            ! fill temperature and salinity arrays
+            IF( TRIM(bf_alias(jp_bdyt_i)%clrootname) == 'NOT USED' )   bf_alias(jp_bdyt_i)%fnow(:,1,:) = rice_tem (jbdy)
+            IF( TRIM(bf_alias(jp_bdyt_s)%clrootname) == 'NOT USED' )   bf_alias(jp_bdyt_s)%fnow(:,1,:) = rice_tem (jbdy)
+            IF( TRIM(bf_alias(jp_bdytsu)%clrootname) == 'NOT USED' )   bf_alias(jp_bdytsu)%fnow(:,1,:) = rice_tem (jbdy)
+            IF( TRIM(bf_alias(jp_bdys_i)%clrootname) == 'NOT USED' )   bf_alias(jp_bdys_i)%fnow(:,1,:) = rice_sal (jbdy)
+            IF( TRIM(bf_alias(jp_bdyaip)%clrootname) == 'NOT USED' )   bf_alias(jp_bdyaip)%fnow(:,1,:) = rice_apnd(jbdy) * & ! rice_apnd is the pond fraction
+               &                                                                         bf_alias(jp_bdya_i)%fnow(:,1,:)     !   ( a_ip = rice_apnd * a_i )
+            IF( TRIM(bf_alias(jp_bdyhip)%clrootname) == 'NOT USED' )   bf_alias(jp_bdyhip)%fnow(:,1,:) = rice_hpnd(jbdy)
+            ! if T_su is read and not T_i, set T_i = (T_su + T_freeze)/2
+            IF( TRIM(bf_alias(jp_bdytsu)%clrootname) /= 'NOT USED' .AND. TRIM(bf_alias(jp_bdyt_i)%clrootname) == 'NOT USED' ) &
+               &   bf_alias(jp_bdyt_i)%fnow(:,1,:) = 0.5_wp * ( bf_alias(jp_bdytsu)%fnow(:,1,:) + 271.15 )
+            ! if T_su is read and not T_s, set T_s = T_su
+            IF( TRIM(bf_alias(jp_bdytsu)%clrootname) /= 'NOT USED' .AND. TRIM(bf_alias(jp_bdyt_s)%clrootname) == 'NOT USED' ) &
+               &   bf_alias(jp_bdyt_s)%fnow(:,1,:) = bf_alias(jp_bdytsu)%fnow(:,1,:)
+            ! if T_s is read and not T_su, set T_su = T_s
+            IF( TRIM(bf_alias(jp_bdyt_s)%clrootname) /= 'NOT USED' .AND. TRIM(bf_alias(jp_bdytsu)%clrootname) == 'NOT USED' ) &
+               &   bf_alias(jp_bdytsu)%fnow(:,1,:) = bf_alias(jp_bdyt_s)%fnow(:,1,:)
+            ! if T_s is read and not T_i, set T_i = (T_s + T_freeze)/2
+            IF( TRIM(bf_alias(jp_bdyt_s)%clrootname) /= 'NOT USED' .AND. TRIM(bf_alias(jp_bdyt_i)%clrootname) == 'NOT USED' ) &
+               &   bf_alias(jp_bdyt_i)%fnow(:,1,:) = 0.5_wp * ( bf_alias(jp_bdyt_s)%fnow(:,1,:) + 271.15 )
+
+            ! make sure ponds = 0 if no ponds scheme
+            IF ( .NOT.ln_pnd ) THEN
+               bf_alias(jp_bdyaip)%fnow(:,1,:) = 0._wp
+               bf_alias(jp_bdyhip)%fnow(:,1,:) = 0._wp
+            ENDIF
+            
+            ! convert N-cat fields (input) into jpl-cat (output)
+            ipl = SIZE(bf_alias(jp_bdya_i)%fnow, 3)            
+            IF( ipl /= jpl ) THEN      ! ice: convert N-cat fields (input) into jpl-cat (output)
+               CALL ice_var_itd( bf_alias(jp_bdyh_i)%fnow(:,1,:), bf_alias(jp_bdyh_s)%fnow(:,1,:), bf_alias(jp_bdya_i)%fnow(:,1,:), &
+                  &              dta_alias%h_i                  , dta_alias%h_s                  , dta_alias%a_i                  , &
+                  &              bf_alias(jp_bdyt_i)%fnow(:,1,:), bf_alias(jp_bdyt_s)%fnow(:,1,:), &
+                  &              bf_alias(jp_bdytsu)%fnow(:,1,:), bf_alias(jp_bdys_i)%fnow(:,1,:), &
+                  &              bf_alias(jp_bdyaip)%fnow(:,1,:), bf_alias(jp_bdyhip)%fnow(:,1,:), &
+                  &              dta_alias%t_i                  , dta_alias%t_s                  , &
+                  &              dta_alias%tsu                  , dta_alias%s_i                  , &
+                  &              dta_alias%aip                  , dta_alias%hip )
+            ENDIF
+         ENDIF
 #endif
-            ENDIF
-            jstart = jstart + dta%nread(1)
-         ENDIF    ! nn_dta(jbdy) = 1
       END DO  ! jbdy
-
-      IF ( ln_apr_obc ) THEN
-         DO jbdy = 1, nb_bdy
-            IF (cn_tra(jbdy) /= 'runoff')THEN
-               igrd = 1                      ! meridional velocity
-               DO ib = 1, idx_bdy(jbdy)%nblenrim(igrd)
-                  ii   = idx_bdy(jbdy)%nbi(ib,igrd)
-                  ij   = idx_bdy(jbdy)%nbj(ib,igrd)
-                  dta_bdy(jbdy)%ssh(ib) = dta_bdy(jbdy)%ssh(ib) + ssh_ib(ii,ij)
-               END DO
-            ENDIF
-         END DO
-      ENDIF
 
       IF ( ln_tide ) THEN
          IF (ln_dynspg_ts) THEN      ! Fill temporary arrays with slow-varying bdy data                           
-            DO jbdy = 1, nb_bdy    ! Tidal component added in ts loop
-               IF ( nn_dyn2d_dta(jbdy) .ge. 2 ) THEN
+            DO jbdy = 1, nb_bdy      ! Tidal component added in ts loop
+               IF ( nn_dyn2d_dta(jbdy) .GE. 2 ) THEN
                   nblen => idx_bdy(jbdy)%nblen
                   nblenrim => idx_bdy(jbdy)%nblenrim
-                  IF( cn_dyn2d(jbdy) == 'frs' ) THEN; ilen1(:)=nblen(:) ; ELSE ; ilen1(:)=nblenrim(:) ; ENDIF 
-                  IF ( dta_bdy(jbdy)%ll_ssh ) dta_bdy_s(jbdy)%ssh(1:ilen1(1)) = dta_bdy(jbdy)%ssh(1:ilen1(1))
-                  IF ( dta_bdy(jbdy)%ll_u2d ) dta_bdy_s(jbdy)%u2d(1:ilen1(2)) = dta_bdy(jbdy)%u2d(1:ilen1(2))
-                  IF ( dta_bdy(jbdy)%ll_v2d ) dta_bdy_s(jbdy)%v2d(1:ilen1(3)) = dta_bdy(jbdy)%v2d(1:ilen1(3))
-               ENDIF
-            END DO
-         ELSE ! Add tides if not split-explicit free surface else this is done in ts loop
-            !
-            CALL bdy_dta_tides( kt=kt, time_offset=time_offset )
-         ENDIF
-      ENDIF
-
-      !
-      IF( ln_timing )   CALL timing_stop('bdy_dta')
-      !
-   END SUBROUTINE bdy_dta
+                  IF( cn_dyn2d(jbdy) == 'frs' ) THEN ; ilen1(:)=nblen(:) ; ELSE ; ilen1(:)=nblenrim(:) ; ENDIF 
+                     IF ( dta_bdy(jbdy)%lneed_ssh   ) dta_bdy_s(jbdy)%ssh(1:ilen1(1)) = dta_bdy(jbdy)%ssh(1:ilen1(1))
+                     IF ( dta_bdy(jbdy)%lneed_dyn2d ) dta_bdy_s(jbdy)%u2d(1:ilen1(2)) = dta_bdy(jbdy)%u2d(1:ilen1(2))
+                     IF ( dta_bdy(jbdy)%lneed_dyn2d ) dta_bdy_s(jbdy)%v2d(1:ilen1(3)) = dta_bdy(jbdy)%v2d(1:ilen1(3))
+                  ENDIF
+               END DO
+            ELSE ! Add tides if not split-explicit free surface else this is done in ts loop
+               !
+               CALL bdy_dta_tides( kt=kt, kt_offset=kt_offset )
+            ENDIF
+         ENDIF
+         !
+         IF( ln_timing )   CALL timing_stop('bdy_dta')
+         !
+      END SUBROUTINE bdy_dta
 
 
